<?php

declare(strict_types=1);

namespace Dedi\SyliusMarketingPlugin\DependencyInjection;

use Symfony\Component\Config\Definition\Builder\TreeBuilder;
use Symfony\Component\Config\Definition\ConfigurationInterface;

final class Configuration implements ConfigurationInterface
{
    public function getConfigTreeBuilder(): TreeBuilder
    {
        $treeBuilder = new TreeBuilder('dedi_sylius_marketing');
        $rootNode = $treeBuilder->getRootNode();

        $rootNode
            ->children()
            ->scalarNode('id')->defaultNull()->end()
            ->booleanNode('enabled')->defaultTrue()->end()
            ->scalarNode('additionalParameters')->defaultValue('')->end()
            ->arrayNode('channels_ids')->canBeUnset()->useAttributeAsKey('code')->prototype('scalar')->end()
            ->end()
        ;

        return $treeBuilder;
    }
}
